%AB_GIBBS_SAMPLING_LIST
% Gibbs sampler for segmenting multiple images (collections)
%
% SC=ab_gibbs_sampling_list(A, X, alpha, NI, C, si, lambda, Ws, Vs, eta_s)
% 
% All the input, except NI, are cell arrays. Each cell contains the
% corresponding value for the ab_gibbs_sampling function. For example A{1}
% contains the affinity matrix for the first image in the collection
%
% Use 'help ab_gibbs_sampling' for more details about the input.
%
% NI: number of iterations of the sampler for generating a new sample. If
%     it is a vector then length of NI samples are generated and the number
%     of iterations before creating sample s is NI(s).
%
% SC: is a cell array containing all the samples for all the images. For 
%     example SC{1} contains the samples for the first image.
%


% AUTORIGHTS
% Copyright (C) 2008-2012 Marco Andreetto
%       
% This file is part of AB_SAMPLER.
% 
% AB_SAMPLER is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2, or (at your option)
% any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software Foundation,
% Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
