/* AUTORIGHTS
Copyright (C) 2008-2012 Marco Andreetto
      
This file is part of AB_SAMPLER.

AB_SAMPLER is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software Foundation,
Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
*/

#include "ab_log.h"

using namespace std;


// defining the global log stream
#ifdef _OUTPUT_ON_FILE_

  // a new stream object is used for logging 
  ofstream flog;
#else

  // the standard error stream is used for logging.
  // in this case 'flog' is just an alias
  ostream &flog=cerr;
#endif

void ab_init_log()
{
#ifdef _OUTPUT_ON_FILE_
  

#if defined(WIN32) || defined(_WIN32) || defined(__WIN32__) 
  // try to open the log file
  flog.open("C:/Temp/debug_info.log", ios::out); 
  
#else  // not a Windows machine. Use Unix filesystem
  flog.open("/tmp/debug_info.log", ios::out);

#endif 

  if (!flog.is_open())
    throw "Unable to open the log file.";
#else // _OUTPUT_ON_FILE_

  // we are using stderr, we do not need to do anyhing

#endif // _OUTPUT_ON_FILE_
}


void ab_close_log()
{
#ifdef _OUTPUT_ON_FILE_
  
  // close the log file is it is open
  if (flog.is_open()) flog.close();

#else
  // we are using stderr, we do not need to do anyhing
#endif  
}
