/* AUTORIGHTS
Copyright (C) 2008-2012 Marco Andreetto
      
This file is part of AB_SAMPLER.

AB_SAMPLER is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software Foundation,
Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
*/

#ifndef _AB_SAMPLER_LIST_
#define _AB_SAMPLER_LIST_

#include <iostream>
#include <vector>

#include "mex.h"

#include "table.h"
#include "my_distributions.h"
#include "ab_sampler.h"


//
// Declaration of the function used by both the serial and the parallel version
//

void CheckListArguments(int, mxArray **, int, mxArray **);
void SetUpAllSamplers(int, mxArray **, std::vector<ABSamplerTypePr> &);
void SetTopicTables(std::vector<ABSamplerTypePr> &, std::vector<table<unsigned> *> &, 
                    std::vector<std::vector<unsigned> *> &);
void GetPriorHyperparam(int, mxArray **, ublas_vector &, double &, 
                        unsigned &, ublas_matrix &);
void reserveOutput(mxArray **, mxArray *&);
void CollectSamplesForAllImages(const std::vector<ABSamplerTypePr> &, 
                                unsigned, mxArray *);
double ComputeLogLikelihoodForAllImages(const std::vector<ABSamplerTypePr> &, 
                                        const std::vector<unsigned> &,
                                        const table<unsigned> &);
void CollectSeedsFromSamplers(const std::vector<ABSamplerTypePr> &, 
                              mxArray *&);
void GetWordTopicTable(const table<unsigned> &, mxArray *&);
void SaveAllSamplersStates(const std::vector<ABSamplerTypePr> &, 
                           unsigned, const char *);

#endif //_AB_SAMPLER_LIST_
