function seg=cleanSeg(seg, sp)

%
% given a segmentation and the superpixels of an image returns a clean
% version of the segmentation with all the superpixels with a uniform label
%

nsp=max(max(sp));
K=max(max(seg));

for h=1:nsp
  
  % all the pixels in this superpixels
  idx=(sp==h);
  
  % get the histogram, find the most frequent label and assign it to all
  % the pixels in the superpixel.
  lh=hist(seg(idx), 1:K);
  [~, lm]=max(lh);
  seg(idx)=lm;
end
% AUTORIGHTS
% Copyright (C) 2008-2012 Marco Andreetto
%       
% This file is part of AB_SAMPLER.
% 
% AB_SAMPLER is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2, or (at your option)
% any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software Foundation,
% Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
