function X=compAvgColorSP(SP, I)

%X=compAvgColorSP(SP, I)
%
% Given an input image I and a partition in superpixels SP return the average 
% RGB color in each superpixel.
% 

% number of superpixels in the image
nSP=max(max(SP));

X=zeros(nSP, 3);

% decompose the image in the three color planes.
Red=I(:,:,1);
Green=I(:,:,2);
Blue=I(:,:,3);


for h=1:nSP
  
  idx=SP==h; % pixels in superpixels h
  
  X(h, 1)=mean(Red(idx));
  X(h, 2)=mean(Green(idx));
  X(h, 3)=mean(Blue(idx));

end

% AUTORIGHTS
% Copyright (C) 2008-2012 Marco Andreetto
%       
% This file is part of AB_SAMPLER.
% 
% AB_SAMPLER is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2, or (at your option)
% any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software Foundation,
% Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
