function compAvgVisualWordColor(xmlFiles)
%
% Compute the average patch color for a given set dictionary
%

% the type of visual words used in the experiments
visual_word_types='texture';
dataset='msrc';
dictionary_size=256;

% get the centers of the kmeans clusters for the texture visual words.
visualWordInfo=getAllVisualWordInfo(visual_word_types, ...
                                    dataset, ...
                                    dictionary_size, ...
                                    xmlFiles);
                                  
% patch size
L=11;
                                  
% compute the values
patch_sum=zeros(3*L*L, dictionary_size);
vwHist=zeros(1, dictionary_size);

for h=1:NF
  
  s=xml_load(xmlFiles{h});
  I=im2double(imread(s.original));
  
  % load the patch info for this image: texture and color descriptors.
  [W, ix, iy]=xmlLoadAllPatchDesc(xmlFiles{h}, 4, visualWordInfo);
  
  
  
  % get also the structure info from the xmlFile
  all_patches=collectPatches(I, ix, iy);
  
  for l=1:dictionary_size
    
    idx=W==l; % get all the visual words of type l
    
    if any(idx)
      patch_sum(:, l)=patch_sum(:, l)+all_patches(:, idx);
    end
  end
  
  vwHist=vwHist+hist(W, 1:dictionary_size);
  
  putDot(h);
end
disp(' ');


%
% Auxiliary functions
%


collectPatches(


% AUTORIGHTS
% Copyright (C) 2008-2012 Marco Andreetto
%       
% This file is part of AB_SAMPLER.
% 
% AB_SAMPLER is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2, or (at your option)
% any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software Foundation,
% Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
