function [hue_words, errlog]=compHueCenters(xmlFiles, ncenters)
%
% Construct the hue_words using kmeans. ncenters is the number of words.
%

% shuffle the files
xmlFiles=xmlFiles(randperm(length(xmlFiles)));

% collect data
desc=[];
ndesc=ncenters*10000;

for h=1:length(xmlFiles)
  [~, ~, ~, hueDesc]=xmlLoadPatchHue(xmlFiles{h}, 4, zeros(10, 36));
  
  desc=cat(1, desc, hueDesc);
  if rows(desc)>ndesc, break; end
  
  putDot(h);
end
disp(' ');
disp(['Number of descriptors for each center: ', num2str(rows(desc)/ncenters)]);
% run kmeans

OPTIONS(1) = 0;
OPTIONS(2) = 10^-4;
OPTIONS(3) = 10^-4;
OPTIONS(5) = 1; % reinitialize centers as random perm of data
OPTIONS(14) = 1000;

disp('Start kmeans');
idx=randperm(rows(desc));
centers=desc(idx(1:ncenters), :);

[hue_words, ~, ~, errlog]=new_kmeans(centers, desc, OPTIONS);

plot(errlog); grid on;

% AUTORIGHTS
% Copyright (C) 2008-2012 Marco Andreetto
%       
% This file is part of AB_SAMPLER.
% 
% AB_SAMPLER is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2, or (at your option)
% any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software Foundation,
% Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
