function intCont=compIntContour(contours, xPos, yPos)
%intCont=compIntContour(contours, xPos, yPos)
% 
%  Compute the intervening contours for the contour map specified in "contours".
%  The two matrices 'xPos' and 'yPos' contain the coordinates of the pixel 
%  used to compute the intervening contour. For example the i-th intervening
%  contour is computed by finding the maximum contour between the pixel 
%  P=(xCoord(i, 0), yCoord(i, 0)) and the pixel Q=(xCoord(i, 1), yCoord(i, 1)).
% 
% 

% check if the corresponding mex file exists
if exist('compIntContour', 'file')~=3
  error('Missing MEx file for function "compIntContour"');
end

% this should call the mex function
intCont=compIntContour(contours, xPos, yPos);

% AUTORIGHTS
% Copyright (C) 2008-2012 Marco Andreetto
%       
% This file is part of AB_SAMPLER.
% 
% AB_SAMPLER is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2, or (at your option)
% any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software Foundation,
% Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
