function [centers, mu, L, errlog]=compVisualWordCenters(type, xmlFileNames, ncenters, normalize)
%
% Compute the visual word centers of the specified type.
%

switch lower(type)
  
  case 'color'
    [centers, errlog]=compColorCenters(xmlFileNames, ncenters);
    
  case 'hue'
    [centers, errlog]=compHueCenters(xmlFileNames, ncenters);
      
  case 'texture' 
    [centers, mu, L, errlog]=compFilterBankCenters(xmlFileNames, ncenters, normalize);

  case 'sift'
    [centers, errlog]=compSiftCenters(xmlFileNames, ncenters);

  otherwise 
    error('Unrecognized visual word type');
end

% if the given visual word type does not use normalization we set the
% relative variable to empty.
if ~exist('mu', 'var'), mu=[]; end
if ~exist('L', 'var'),   L=[]; end

% AUTORIGHTS
% Copyright (C) 2008-2012 Marco Andreetto
%       
% This file is part of AB_SAMPLER.
% 
% AB_SAMPLER is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2, or (at your option)
% any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software Foundation,
% Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
