function convert_data_for_new_code(xmlFiles, outFile)
%
% Given the collections of images specified in 'xmlFiles' returns a single
% text file with all the visual words in the corpus.
%

dictionary_size=1024;          % number of visual words in the dict.
eta=100;                       % hyperparam for the topic prior dist.
grid_step=4;                   % step of the regular grid in the image
dataset='msrc';                % dataset name
visual_word_types={'texture'}; % type of visual word used

NF=length(xmlFiles); 

% get the centers of the kmeans clusters for the texture visual words.
visualWordInfo=getAllVisualWordInfo(visual_word_types, dataset, ...
                                    dictionary_size, xmlFiles);
out=fopen(outFile, 'w');

for h=1:NF
  
  % load the patch info for this image: texture and color descriptors.
  Ws=xmlLoadAllPatchDesc(xmlFiles{h}, grid_step, visualWordInfo);
  
  % write the visual word in a single line of the out file
  fprintf(out, '%d ', Ws-1);
  fprintf(out, '\n');
  
  putDot(h);
end
disp(' ');

fclose(out);

% AUTORIGHTS
% Copyright (C) 2008-2012 Marco Andreetto
%       
% This file is part of AB_SAMPLER.
% 
% AB_SAMPLER is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2, or (at your option)
% any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software Foundation,
% Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
