function C=extractKM(samples, K)
%EXTRACTMAP extracts kmenas clustering from samples
%   C=EXTRACTKM(SAMPLES) extracts for each observation the k-means
%   clustering assignment based on the samples 'samples'. 
%   The k-means is computed considering for each observation the vector of
%   assignments.
%   



% %   If the input 'fixLabels' is specified then the k-means is not performed
% %   for those observation that have that particular labels

% number of observations
N=rows(samples);

if nargin<2
  % get the number of cluster as the maximum value in the samples
  K=max(max(samples));
end

% Options for the netlab kmeans
options(1) = 0;
options(2) = 10^-2;
options(3) = 10^-2;
options(5) = 1; % reinitialize centers as random perm of data
options(14) = 100;

% clustering is obtrained via kmeans on the samples
idx=randperm(rows(samples));
[centers, options, post] = kmeans(samples(idx(K),:), samples, options);
C=ind2labels(post);

% AUTORIGHTS
% Copyright (C) 2008-2012 Marco Andreetto
%       
% This file is part of AB_SAMPLER.
% 
% AB_SAMPLER is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2, or (at your option)
% any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software Foundation,
% Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
