function center_file_name=getCenterFileName(expInfo) 
%
% [centers, mu, L, info]=getVisualWordCenters(type)
%
% Given the identifier for the dataset returns the MAT file with the visual
% word centers.
%

% extract the number visual words in the ddictionary
V_str=num2str(expInfo.dictionary_size);

% extract the type of visual words: sift, color, texture, gabor.
visual_word_type=[expInfo.visual_word_type, '_centers_'];

% load the kmeans centers based on the type of dataset. The patches for the
% texture visual words are normalized.

switch lower(expInfo.dataset_name)
  
  case 'msrc'
    center_file_name=[visual_word_type, V_str, '_msrc_20080731_normalized'];

  case 'coast'
    center_file_name=[visual_word_type, V_str, '_coast_scene_20090406'];
    
  case 'forest'
    center_file_name=[visual_word_type, V_str, '_forest_scene_20090406'];
    
  case 'highway'
    center_file_name=[visual_word_type, V_str, '_highway_scene_20090406'];
    
  case 'inside_city'
    center_file_name=[visual_word_type, V_str, '_inside_city_scene_20090406'];
    
  case 'mountain'
    center_file_name=[visual_word_type, V_str, '_mountain_scene_20090406'];
    
  case 'open_country'
    center_file_name=[visual_word_type, V_str, '_open_country_scene_20090406'];
    
  case 'scene'
    center_file_name=[visual_word_type, V_str, '_scene_20090406'];
    
  case 'street'
    center_file_name=[visual_word_type, V_str, '_street_20090406'];
    
  case 'tall_building'
    center_file_name=[visual_word_type, V_str, '_tall_building_20090406'];
    
  otherwise
    error('Unrecognize dataset');

end

% AUTORIGHTS
% Copyright (C) 2008-2012 Marco Andreetto
%       
% This file is part of AB_SAMPLER.
% 
% AB_SAMPLER is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2, or (at your option)
% any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software Foundation,
% Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
