function [ix, iy, ix_range, iy_range]=getGridPositions(width, height, step)

M=height; % number of rows
N=width;  % number of cols

% the position of the grid nodes on the x axis (columns), and y axis (rows)
start=step; % previously we used 10, now we use the same step used for the grid
ix_range=start:step:(N-step+1);
iy_range=start:step:(M-step+1);

% construct the position 'ix' and 'iy' of the visual words. This two
% vectors are completely specified by the image size and the grid step.
[ix, iy]=meshgrid(ix_range, iy_range);
ix=ix(:); % make them column vectors
iy=iy(:); 

% AUTORIGHTS
% Copyright (C) 2008-2012 Marco Andreetto
%       
% This file is part of AB_SAMPLER.
% 
% AB_SAMPLER is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2, or (at your option)
% any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software Foundation,
% Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
