function C=ind2labels(I)
%
% Transform an indicator matrix I corresponding to a cluster assignment
% into the equivalent label assignment vector C.
% if I is a matrix of dimension NxK then C is a vector of dimension N and
% with max(C)=K
%

N=rows(I); % number of observations
K=cols(I); % number of clusters

C=zeros(N, 1);
for k=1:K,
  C(I(:,k)==1)=k;
end

% AUTORIGHTS
% Copyright (C) 2008-2012 Marco Andreetto
%       
% This file is part of AB_SAMPLER.
% 
% AB_SAMPLER is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2, or (at your option)
% any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software Foundation,
% Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
