% path for the include files of the boost library.
BOOST_INCLUDE_PATH='/home/marco/research/libraries/boost/include';

% type of system (mexglx, mexa64)
ARCH='mexa64';
% ARCH='mexglx';

switch ARCH

  case 'mexglx'
    % create the 3 mex files for the system
    fprintf('Creating ab_gibbs_sampling.mexglx...');
    eval(['mex -I', BOOST_INCLUDE_PATH, ...
        ' -output ab_gibbs_sampling.mexglx ', ...
        ' ab_gibbs_sampling.cpp ab_sampler.cpp ab_log.cpp my_distributions.cpp ']);
    fprintf('done\n');
    
    fprintf('Creating ab_gibbs_sampling_list.mexglx...');
    eval(['mex -I', BOOST_INCLUDE_PATH, ...
        ' -output ab_gibbs_sampling_list.mexglx ', ...
        ' ab_gibbs_sampling_list.cpp ab_sampler.cpp my_distributions.cpp ab_sampler_list.cpp']);
    fprintf('done\n');

    fprintf('Creating scale_dist.mexglx...');
    mex scale_dist.cpp;
    fprintf('done\n');

    fprintf('Creating mergeSmallComp.mexglx...');
    mex mergeSmallComp.cpp;
    fprintf('done\n');

  case 'mexa64'
    % create the 3 mex files for the system
    fprintf('Creating ab_gibbs_sampling.mexa64...');
    eval(['mex -I', BOOST_INCLUDE_PATH, ...
        ' -output ab_gibbs_sampling.mexa64 ', ...
        ' ab_gibbs_sampling.cpp ab_sampler.cpp ab_log.cpp my_distributions.cpp']);
    fprintf('done\n');
    
    fprintf('Creating ab_gibbs_sampling_list.mexa64...');
    eval(['mex -I', BOOST_INCLUDE_PATH, ...
        ' -output ab_gibbs_sampling_list.mexa64 ', ...
        ' ab_gibbs_sampling_list.cpp ab_sampler.cpp ab_log.cpp my_distributions.cpp ab_sampler_list.cpp']);
    fprintf('done\n');

    fprintf('Creating scale_dist.mexa64...');
    mex scale_dist.cpp;
    fprintf('done\n');

    fprintf('Creating mergeSmallComp.mexa64...');
    mex mergeSmallComp.cpp;
    fprintf('done\n');

  otherwise
    error('Unrecognized architecture');
end

% AUTORIGHTS
% Copyright (C) 2008-2012 Marco Andreetto
%       
% This file is part of AB_SAMPLER.
% 
% AB_SAMPLER is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2, or (at your option)
% any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software Foundation,
% Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
