function [W, ix, iy, scales]=loadPatchInfo_sift(ifn, step, recompute, type)

if nargin<2, step=2; end;
if nargin<3, recompute=false; end;
if nargin<4, type='msrc'; end;


% load the image
I=im2double(imread(ifn));
M=rows(I);
N=cols(I);

% the position of the grid nodes on the x axis (columns), and y axis (rows)
ix_range=5:step:N;
iy_range=5:step:M;

% construct the position of the color words
[ix, iy]=meshgrid(ix_range, iy_range);

ix=ix(:);
iy=iy(:);

% we should assign a set of random scales. At the moment we generate
% uniformly between s*(20-30). This should be big enough.
s=0.5;
scales=randint(length(ix), 1, s*[10 20]);

% get the filter version of the image
descfn=[ifn, '.sift_desc.mat'];
labelsfn=[ifn, '.sift_labels.mat'];

W=[];
% if (~exist(descfn, 'file') || recompute)
%   
%   tic;
%   % create the sift descriptors of the given image
%   desc=compSiftDesc(I, [ix, iy, scales]);
%   
%   save(descfn, 'desc', 'ix', 'iy', 'scales');
%   toc;
% end

load(descfn, 'desc');

if (~exist(labelsfn, 'file') || recompute)  
  switch lower(type)
    case 'msrc'
      load('/home/marco/research/projects/AB_Clustering/prepare_data/sift_centers_msrc_256.mat',...
           'sift_words');
         
    case 'horse'
      load('/home/marco/research/projects/AB_Clustering/prepare_data/sift_centers_256c.mat', ...
           'sift_words');
         
    case 'labelme'
      load('/home/marco/research/projects/AB_Clustering/prepare_data/sift_centers_labelme_256.mat', ...
           'sift_words');
         
    case 'scenes'
      load('/home/marco/research/projects/AB_Clustering/prepare_data/sift_centers_scenes_256.mat', ...
           'sift_words');
         
    otherwise
      error('Unrecognize dataset');
         
  end
  
  [d, W]=mindist(sift_words', desc');
  W=W(:);
  
  save(labelsfn, 'W');
  
end

% load the centers and compute the visual words
load(labelsfn, 'W');

% AUTORIGHTS
% Copyright (C) 2008-2012 Marco Andreetto
%       
% This file is part of AB_SAMPLER.
% 
% AB_SAMPLER is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2, or (at your option)
% any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software Foundation,
% Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
