function make_ground_truth_MSRCv2

gtDir='/common/marco/clustering/datasets/MSRC_v2/Images';
gtFiles=getAllFilesInDir(gtDir, '*.gt_seg.mat');

class_sizes=zeros(1, 24);

for h=1:length(gtFiles)
  % compute the histogram
  load(gtFiles{h}, 'gt_seg');
  if max(max(gt_seg))>length(class_sizes) %#ok<NODEF>
    error('Unrecognized labels');
  end
  class_sizes=class_sizes+hist(gt_seg(:), 1:length(class_sizes));
  
  putDot(h);
end
disp(' ');

class_labels={'nolabel', ...           
        'building', ...           
        'grass', ...           
        'tree', ...               
        'cow', ...                
        'horse', ...              
        'sheep', ...              
        'sky', ...                
        'mountain', ...           
        'aeroplane', ...           
        'water', ...              
        'face', ...               
        'car', ...                
        'bicycle', ...            
        'flower', ...                     
        'sign', ...                     
        'bird', ...                     
        'book', ...                     
        'chair', ...                     
        'road', ...                     
        'cat', ...                     
        'dog', ...                    
        'body', ...                     
        'boat', ...           
};

save MsrcV2_label_size class_labels class_sizes;


% imageDir='/common/marco/clustering/datasets/MSRC_v2/Images';
% gtDir='/common/marco/clustering/datasets/MSRC_v2/GroundTruth';
% 
% % get all the files in the ground truth direcotry and compute the
% % corresponsing labels mask.
% gtFiles=getAllFilesInDir(gtDir, '*.bmp');
% 
% % get all the images to double check the results.
% imageFiles=getAllFilesInDir(imageDir, '*.bmp');
% 
% % table with color coded labels
% rgbLabels=[  0     0     0
%            128     0     0
%              0   128     0
%            128   128     0    
%              0     0   128    
%            128     0   128    
%              0   128   128    
%            128   128   128    
%             64     0     0    
%            192     0     0    
%             64   128     0    
%            192   128     0    
%             64     0   128    
%            192     0   128    
%             64   128   128    
%            192   128   128    
%              0    64     0    
%            128    64     0    
%              0   192     0    
%            128    64   128    
%              0   192   128    
%            128   192   128    
%             64    64     0    
%            192    64     0    
% ]/255;
% 
%   
% % list of names for the 
% labels={'nolabel', ...           
%         'building', ...           
%         'grass', ...           
%         'tree', ...               
%         'cow', ...                
%         'horse', ...              
%         'sheep', ...              
%         'sky', ...                
%         'mountain', ...           
%         'aeroplane', ...           
%         'water', ...              
%         'face', ...               
%         'car', ...                
%         'bicycle', ...            
%         'flower', ...                     
%         'sign', ...                     
%         'bird', ...                     
%         'book', ...                     
%         'chair', ...                     
%         'road', ...                     
%         'cat', ...                     
%         'dog', ...                    
%         'body', ...                     
%         'boat', ...           
% };
% 
% 
% % process all the images create a mat file with the label mask and save it
% % in the file directory.
% for h=1:length(gtFiles)
%   I=im2double(imread(imageFiles{h}));
%   GT=im2double(imread(gtFiles{h}));
%   
%   vl_tightsubplot(1,3,1); imshow(I);
%   vl_tightsubplot(1,3,2); imshow(GT);
%   
%   gt_seg=zeros(rows(I), cols(I));
%   
%   % check all the labels
%   for l=1:length(labels)
%     idx=(GT(:,:,1)==rgbLabels(l, 1) & ...
%          GT(:,:,2)==rgbLabels(l, 2) & ...
%          GT(:,:,3)==rgbLabels(l, 3));
%     
%     gt_seg(idx)=l;
%   end
%   
%   GT2=ind2rgb(gt_seg, rgbLabels);
%   vl_tightsubplot(1,3,3); imshow(GT2);
%   save([imageFiles{h}, '.gt_seg.mat'], 'gt_seg');
%   pause(1);
% end
% 

% AUTORIGHTS
% Copyright (C) 2008-2012 Marco Andreetto
%       
% This file is part of AB_SAMPLER.
% 
% AB_SAMPLER is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2, or (at your option)
% any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software Foundation,
% Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
