function [Cs_all, R]=map_topic_segmentation(betas, Ws)
%
% Given the topic distributions 'betas' and the list of visual words 'W'
% returns the MAP assignment
% 

NF=length(Ws);
Cs_all=cell(1, NF);
R=cell(1, NF);

% iterate over all the images.
for h=1:NF
  
  % get the posterior for each observation
  post=betas(:, Ws{h});
  
  % compute the MAP assignment
  [foo, C]=max(post);
  Cs_all{h}=C(:);
  R{h}=post';
end


% AUTORIGHTS
% Copyright (C) 2008-2012 Marco Andreetto
%       
% This file is part of AB_SAMPLER.
% 
% AB_SAMPLER is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2, or (at your option)
% any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software Foundation,
% Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
