function [affFileName, patchFileName]=retriveDataFiles(imageFileName, affType)
%
% given the location of 'imageFileName' it returns the locations of the files
% with the affinities and the patches.
%

%
% at the moment all the files are in Eugenes directory. We need to substitute 
% the path prefix.
%

if (strcmp(imageFileName(1:45), '/common/bart/core/work/databases/databases006'))
  % we are using Eugenes images. We need to substitute the prefix
  
  % prefix for the images
  baseDirImages='/common/bart/core/work/databases/databases006/caltech4freeman130rows/';
  
  % prefix for the affinities
  baseDirAff='/common/marco/clustering/datasets/Eugene/';
  
  % get the file name only
  fileName=imageFileName(length(baseDirImages):end);

else
  % the prefix is the same we just need to get add the extension. 
%   error('Only eugene images are supported at the moment');

  baseDirAff='';
  fileName=imageFileName;
  
end
  
% compose the affinity file name
switch lower(affType)
  case 'lihi'
    % filename for the affinities if we are using lihi method
    affFileName=strcat(baseDirAff, fileName, '.R_11.mat');

  case 'ic'
    % filename for the affinities if we are using Intervening countour
    affFileName=strcat(baseDirAff, fileName, '.ic_aff.mat');
    
  case 'berkeley'
    % filename for the affinities if we are using Intervening countour
    affFileName=strcat(baseDirAff, fileName, '.berkeley_aff.mat');
    
  otherwise
    error('Unrecognize type of affinities');
end


% compose the patch file name
patchFileName=strcat(baseDirAff, fileName, '.patch_info.mat');

% AUTORIGHTS
% Copyright (C) 2008-2012 Marco Andreetto
%       
% This file is part of AB_SAMPLER.
% 
% AB_SAMPLER is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2, or (at your option)
% any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software Foundation,
% Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
