function showVideoFromSamples(imageNumber, im)

if ~exist('im', 'var')
  % Inverse mapping: 
  im=[3   1   7   1   5   9   6   9   2   1 ...
    6   1   8   4  10   2  11   3   7   1];
end

% load the files 
load /home/marco/research/projects/AB_Clustering/testing/xmlMsrcV1FileNames.mat ...
  xmlMsrcV1FileNames;

idx=imageNumber; % index of the image to use
s=readXMLfile(xmlMsrcV1FileNames{idx}); % info for the image

% load the image and samples
I=im2double(imread(s.original_name));
destDir='/common/marco/clustering/results/Journal/20100626e/';
load(fullfile(destDir, ['samples_', num2str(idx, '%04d')]), 'C');
for s=1:cols(C)  %#ok<NODEF>
  
  Cs=zeros(size(C(:, s))); % extract the sample and relabelit
  for k=1:length(im);
    Cs(C(:, s)==k)=im(k);
  end
%   Cs=C(:, s);
  
  
  % construct the image from the samples
  if (cols(I)>rows(I))
    nr=52; nc=79;
  else
    nr=79; nc=52;
  end
  
  segImage=reshape(Cs, nr, nc);
  segImage=imresize(segImage, 4, 'nearest');

  % at this point the image is not in the right position, we center the
  % image and propagate the border
  segImage=center_and_replicate(segImage, 4, rows(I), cols(I));
  
  % color the segmentions
%   segImage=color_segments(segImage, 20, [], seg_color(20));
  segImage=color_segments(segImage, 11, [], GetClassColors);
  
  % display the image and the segments at a 0.1 rate;
  imshow([I segImage]);
  if mod(s, 10)==0, disp(num2str(s)); end
  
  if (s <10)
    pause;
  else
    pause(0.1);
  end
end


function outSeg=center_and_replicate(inSeg, grid_step, M, N)

% TODO: this may be off of one pixel. In the unlikeliy case the
% segmentation resuts improve to pixel accuracy this may be an issue.

for h=1:(grid_step-1)
  inSeg=[inSeg(:, 1) inSeg inSeg(:, end)]; %#ok<AGROW>
  inSeg=[inSeg(1, :); inSeg; inSeg(end, :)]; %#ok<AGROW>
end

outSeg=inSeg(1:M, 1:N);

function class_colors=GetClassColors

class_colors= ...
  [ 0.7 0.7 0.7; ... % no label / junk
    1.0 0.0 0.0; ... % cows
    0.0 1.0 0.0; ... % grass
    0.0 0.0 0.5; ... % cars
    0.0 1.0 1.0; ... % sea
    0.5 0.8 0.3; ... % buildings
    0.1 0.5 0.1; ... % foliage
    1.0 1.0 0.0; ... % sky
    1.0 1.0 1.0; ... % airplanes
    0.8 0.0 0.8; ... % bikes
    1.0 0.5 0.0];    % faces



% AUTORIGHTS
% Copyright (C) 2008-2012 Marco Andreetto
%       
% This file is part of AB_SAMPLER.
% 
% AB_SAMPLER is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2, or (at your option)
% any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software Foundation,
% Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
