function R=spTopicResp(SP, ix, iy, W, phi, thetas)

%
%
%

K=rows(phi);  % number of topics/segments
pW=phi(:, W).*repmat(thetas', 1, length(W)); % posterior of the topics 
nSP=max(max(SP)); % number of superpixels

% get all the superpixel labels for each visual word.
ind=sub2ind([rows(SP) cols(SP)], round(iy), round(ix));
SPLabels=SP(ind);

% preallocate the output
R=zeros(nSP, K);

% iterate over all the superpixels and collect all the posterior prob.
for h=1:nSP
  
  % indeces of the visual words in the superpixels h
  idx=(SPLabels==h); 
  
  % log-likelihood of being in each of the K topics
  ll=row_sum(log(pW(:, idx)+eps))';
  ll=ll-max(ll); % remove the largest component
  
  % this is the log likelihood. We need to no
  R(h, :)=exp(ll);
end

% normalize each row to one
R=scale_rows(R, row_sum(R));

% AUTORIGHTS
% Copyright (C) 2008-2012 Marco Andreetto
%       
% This file is part of AB_SAMPLER.
% 
% AB_SAMPLER is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2, or (at your option)
% any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software Foundation,
% Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
