%
% Use this script to test some properties of the superpixels version of the
% AB model.
% 

clear

imageFileName='Utah_original.png'; % this is the utah stone arch

% read an image and compute the UCM and the superpixel segmentation
I=im2double(imread(imageFileName));
% [~, ~, Contours]=TA_gPb_affinities(I);
% [~, ~, ucm]=TA_ucm_affinities(I);
% save([imageFileName, '.mat'], 'Contours', 'ucm');
load([imageFileName, '.mat'], 'Contours', 'ucm'); % load cached res.

% % a little visualization 
% vl_tightsubplot(1, 3, 1); imagesc(I); axis off equal;
% vl_tightsubplot(1, 3, 2); imagesc(Contours); axis off equal;
% vl_tightsubplot(1, 3, 3); imagesc(ucm); axis off equal;

% % display the evolution of the superpixels depending on the threshold
% % parameter T
% T=[0.01:0.01: 0.1 0.2:0.1:1];
% for h=1:length(T)
%   figure(1); clf;
%   
%   % compute the superpixels, 
%   SP=ucm2Superpixels(ucm, T(h));
%   
%   % compute the average color in each superpixels
%   avgSP=propSPValue(compAvgColorSP(SP, I), SP);
%   
%   vl_tightsubplot(1, 3, 1); 
%   image(I); axis off equal;
%   title('Original image');
%   
%   vl_tightsubplot(1, 3, 2); 
%   imagesc(SP); axis off equal;
%   title(['# superpixels: ', num2str(max(max(SP)))]);
%   
%   vl_tightsubplot(1, 3, 3); 
%   image(avgSP); axis off equal;
%   title('Average color superpixels');
%   
%   suptitle(['Threshold: ', num2str(T(h), '%.2f')]);
%   
%   pause;
% end

% compute the superpixels 
SP=ucm2Superpixels(ucm, 0.05);

% compute a grid of dimension 4x4 and show their membership
[ix, iy, ixRng, iyRng]=getGridPositions(cols(I), rows(I), 4);

% transform the ix, ix coordinates into a linear index in the matrix and 
% select only these values of the superpixels map.
SPgrid=SP(sub2ind([rows(I), cols(I)], iy, ix));

for h=1:max(max(SP))
  
  idx=(SPgrid==h);
  
  figure(1); clf;
  image(I);
  hold on;
  plot(ix(idx), iy(idx), '.');
  hold off;
  axis off equal;
  
  pause;
end

% compute IC between all pairs of grid points.


% AUTORIGHTS
% Copyright (C) 2008-2012 Marco Andreetto
%       
% This file is part of AB_SAMPLER.
% 
% AB_SAMPLER is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2, or (at your option)
% any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software Foundation,
% Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
