%
% Test the compIntContour.cpp
%

clear;

% load all the 
  


%% Read an image and compute the ultrametric contour map
I=im2double(imread('Utah_original.png'));

imwrite(I, 'tmp_image.jpg', 'Quality', 100);
% globalPb('tmp_image.jpg', 'Yellowbird.png.mat');
load Utah_original.png.mat gPb_orient gPb_thin;

ucm=im2double(contours2ucm(gPb_orient, 'imageSize'));
gPb_thin=im2double(gPb_thin);

% compute one level of the segmentation with a low scale to preserve many
% superpixels
T=0.01;
[SP, A, cx, cy]=ucm2Superpixels(ucm, T);

% X=compAvgColorSP(SP, I);
% pI=propSPValue(X, SP);
% imshow(pI);

% compute the visual words
load ../testing/xmlMsrcV1FileNames.mat xmlMsrcV1FileNames;
xmlFiles=xmlMsrcV1FileNames;
visualWordInfo=getAllVisualWordInfo({'color'}, 'msrc', 1024, xmlFiles);

avgColors=compAvgColorSP(SP, I);
[~, W]=mindist(visualWordInfo.centers', avgColors');
W=W';

% run the single image segmentation algorithm
K=5;
R=ab_variational_single(A, W, 20*ones(1, K), 50, 10, 1024);
[~, C]=max(R, [], 2);

IA=propSPValue(C, SP);
imagesc(IA); axis off equal;

% % display the segmentation boundarirs and the centers computed for the
% % affinities
% figure(11); imshow(segImage(I, SP)); axis off equal;
% hold on; plot(cx, cy, 'g.', 'MarkerSize', 20); hold off;

% % display the affinities between the pixels.
% figure(13); clf
% for h=1:rows(A)
%   % affinities between superpixels h and all the other superpixels
%   IA=propSPValue(A(:, h), SP);
%   
%   subplot(1,2,1); 
%   image(I); %putCrossInImage(I, cx(h), cy(h))); 
%   axis off equal;
%   
%   subplot(1,2,2);
%   imagesc(IA);
%   axis off equal;
%   colormap gray;
% 
%   pause;
% end


% % enlarge the contours
% ucm=maxfilt2(ucm, [3 3]);
% gPb_thin=maxfilt2(gPb_thin, [3 3]);
% 
% % rescale everything by a factor 4. to be able to manage the points
% s=0.5;
% ucm=imresize(ucm, s, 'bilinear');
% gPb_thin=imresize(gPb_thin, s, 'bilinear');
% I=imresize(I, s, 'bilinear');
% 
% M=rows(I);
% N=cols(I);
% 
% %% Compute the grid points.
% [ix, iy, ix_range, iy_range]=getGridPositions(N, M, 1);
% idx=sub2ind([M, N], iy, ix);
% 
% gridPoint=zeros(M, N);
% gridPoint(idx)=1;
% 
% % compute the linear index of each pixel used in the following computation
% indImage=reshape(1:(M*N), M, N);
% indImage=indImage.*gridPoint;
% 
% indImage=indImage(iy_range, :);
% indImage=indImage(:, ix_range);
% 
% % compute the neighbors for each point
% L=80;
% LL=2*L+1;
% 
% nn=im2col(addborder(indImage, L, L, 0), [LL LL], 'sliding');
% valid=find(nn(:)>0); 
% 
% nnSize=LL*LL;
% centerPixel=(nnSize+1)/2;
% 
% cp=repmat(nn(centerPixel, :), nnSize, 1);
% 
% ind_col = nn(valid); % linear index for the pixels destination of the ic.
% ind_row = cp(valid); % linear index for the pixels origin of the ic.
% 
% 
% %% Compute intervening countours for the ucm
% [Py Px]=ind2sub([M, N], ind_row);
% [Qy Qx]=ind2sub([M, N], ind_col);
% 
% Nx=[Px Qx]; Ny=[Py Qy];
% intContour=compIntContour(gPb_thin, Nx, Ny);
% 
% 
% %% Create the affinity matrix
% 
% % a1=exp(-(intContour/0.1));
% % A1=sparse(ind_row, ind_col, a1, M*N, M*N);
% % 
% a2=exp(-(intContour/0.1).^2);
% A2=sparse(ind_row, ind_col, a2, M*N, M*N);
% A2=full(A2);
% 
% max_dist=1-full(sparse(ind_row, ind_col, ones(length(ind_col), 1)));
% dist=sparse(ind_row, ind_col, intContour, M*N, M*N);
% dist=max_dist+full(dist);
% 
% image_colors=reshape(I, rows(dist), 3);
% 
% clear intContour ind_row ind_col a2;
% save('image3.png.mat', '-append', 'dist', 'A2', 'image_colors');
% 
% %% Check that the contours make se
% % vl_tightsubplot(1, 3, 1); imshow(I); title('original');
% 
% for m=4:4:M
%   for n=4:4:N
%     h=sub2ind([M, N], m, n);
% 
% %     % reshape and display
% %     t0=full(dist(:, h));
% %     t0(h)=1;
% %     t0=max(t0, gPb_thin(:));
% %     IIC=reshape(t0, M, N);
% 
% %     % reshape and display
% %     t1=max(full(A1(:, h)), gPb_thin(:));
% %     IA1=reshape(t1, M, N);
%     
%     % reshape and display
%     t2=max(full(A2(:, h)), gPb_thin(:));
%     IA2=reshape(t2, M, N);
%     
% %     vl_tightsubplot(1,2,1); imagesc(IIC); axis off; axis equal;
% %     vl_tightsubplot(1,2,1); imagesc(IA1); axis off; axis equal;
% %     vl_tightsubplot(1,2,2); 
%     image(64*IA2); axis off; axis equal;
%     
%     pause(0.15);
%   end
% end
% 
% 
% %%  Compute MDS on the similarity metric
% 
% % clear;
% 
% % distance matrix
% load image3.png.mat dist image_colors;
% 
% % set the diagonal to zero
% for i=1:rows(dist)
%   dist(i,i)=0; %#ok<SAGROW>
% end
% 
% % % try squared distances
% % dist=dist.^2;
% 
% step=1;
% dist=dist(1:step:end, 1:step:end);
% image_colors=image_colors(1:step:end, :);
% 
% % compute the classical MDS
% tic;
% % [Y, s]=mdscale(dist, 3, 'Criterion', 'metricstress');
% [Y, e]=cmdscale(dist);
% % load IC_dist.mat Y e;
% toc;
% 
% % Two and three dimension embedding
% Y2=Y(:,1:2);
% Y3=Y(:,1:3);
% disp('Done!!!');
% 
% 
% %% Display the MDS 
% 
% % % load the embedding and the image
% % load IC_dist.mat Y2 image_colors;
% % Y=Y2;
% 
% % reconstruct the image
% I=reshape(image_colors, [M, N, 3]); % scaled image
% 
% figure(13); 
% 
% while true
%   
%   % display the image 
%   vl_tightsubplot(1,2,1); imshow(I);
%   
%   % get a pixel in the image and compute the index corresponding point 
%   % in the embedding
%   [ix, iy]=ginput(1);
%   i=floor(iy); j=floor(ix);
%   h=sub2ind([rows(I), cols(I)], i, j);
%   
%   % display the embedding
%   vl_tightsubplot(1,2,2); cla;
%   scatter(Y(:,1), Y(:,2), [], image_colors);
% %   plot3(Y(:,1), Y(:,2), Y(:,3), '.b', 'MarkerSize', 10);
%   % highlight the selected point
%   hold on
%   plot3(Y(h,1), Y(h,2), Y(h,3), 'ro', 'MarkerSize', 15, 'LineWidth', 5);
%   hold off
%   axis off equal;
%   drawnow;
%   
% end  
% 
% 
% % % displat the original figure
% % for h=1:10:rows(Y)
% %   clf
% %   
% %   vl_tightsubplot(1,2,1); 
% %   scatter(Y(:,1), Y(:,2), [], image_colors(1:step:end, :));
% %   hold on
% %   plot(Y(h,1), Y(h,2), 'ro', 'MarkerSize', 15, 'LineWidth', 5);
% %   hold off
% %   axis off equal;
% %   
% %   vl_tightsubplot(1,2,2); 
% %   imshow(I);
% %   [i, j]=ind2sub([rows(I), cols(I)], h);
% %   hold on
% %   plot(j, i, 'ro', 'MarkerSize', 15);
% %   hold off
% %   axis off equal;
% %   
% %   pause(1);
% % end
% % 
% 
% % % padding to save it in 3D.
% % Y=[Y zeros(rows(Y), 1)];
% % 
% % saveSpheresInVRML(Y', 0.01, 'mds_embedding.wrl', image_colors');
% 
% 
% %%
% 
% % %% check triangular inequality 
% % 
% % load IC_dist.mat dist
% % 
% % % set the diagonal to zero
% % for i=1:rows(dist)
% %   dist(i,i)=0; %#ok<SAGROW>
% % end
% % 
% % N=rows(dist);
% % 
% % t=0;
% % for h=1:N
% %   for k=(h+1):N
% %     for l=(k+1):N
% %       if (dist(h, k)>dist(h, l)+dist(l, k))
% %         t=t+1;
% %       end
% %     end
% %   end
% % end
% % 
% % dist(['Number of violations: ', num2str(t)]);
% % dist(['ratio: ', num2str(t)/nchoosek(N, 3)]);
% 

% AUTORIGHTS
% Copyright (C) 2008-2012 Marco Andreetto
%       
% This file is part of AB_SAMPLER.
% 
% AB_SAMPLER is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2, or (at your option)
% any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software Foundation,
% Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
