function colors=xmlCompAverageSegColors(xmlFile)

%
% Compute the average colors for the segments
%

disp('Compute the average color for each segment');

% load the file structure with all the info about the experiment
expInfo=readXMLfile(xmlFile);

% load the segmentations: both matlab and png
segFiles=getAllFilesInDir(expInfo.destDir, 'seg_map_*.mat');

% colors of the segments
colors=zeros(expInfo.K, 3);
seg_sizes=zeros(expInfo.K, 1);

% iterate over all the files used in this experiment and generate and
% generate the segmentation images
for h=1:length(segFiles)
  
  % load the segmentation 
  load(segFiles{h}, 'segImageMAP');
  
  % read the original image
  I=double(imread(expInfo.data_file_info{h}.original_name))/255;
  
  % iterate over all the topics
  for k=1:expInfo.K
    idx=(segImageMAP==k);
    seg_sizes(k)=seg_sizes(k)+sum(sum(idx));
    colors(k, :)=colors(k, :)+getSumColors(I, idx);
  end
  
  putDot(h);
end
disp(' ');
  
% compute the mean
colors=colors./repmat(seg_sizes, 1, 3);

disp(' ');



function c=getSumColors(I, idx)

c=[0 0 0];

for h=1:3
  p=I(:,:, h);
  p=p(:);
  c(h)=sum(p(idx(:)));
end
% AUTORIGHTS
% Copyright (C) 2008-2012 Marco Andreetto
%       
% This file is part of AB_SAMPLER.
% 
% AB_SAMPLER is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2, or (at your option)
% any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software Foundation,
% Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
