function gt_seg=xmlExtractGroundTruth(pos, xmlFile)
%
% Extract the groundtruth labels for the specified image file.
%

% collect the ground truth
s=xml_load(xmlFile);    % load the xml
load(s.ground_truth_name, 'gt_seg');  % load the gt for the whole image

% extract only the labels for the selected position
row_num=rows(gt_seg);  %#ok<NODEF>
col_num=cols(gt_seg);

% the first coordinate is the x which correspond to the column of the
% image. The second coordinate is the y which correspond to the rows.
c_idx=round(pos(:, 1));
r_idx=round(pos(:, 2));

% we need to convert the indeces to the linear case
idx=sub2ind([row_num, col_num], r_idx, c_idx);

gt_seg=gt_seg(idx);

% AUTORIGHTS
% Copyright (C) 2008-2012 Marco Andreetto
%       
% This file is part of AB_SAMPLER.
% 
% AB_SAMPLER is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2, or (at your option)
% any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software Foundation,
% Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
