function [Ae, Xe, row_num, col_num]=xmlExtract_IC_Pb(pos, xmlFileName) %#ok<STOUT>
%
% Extract the Intervening countout for the points of position 'pos'
%


%
% Check if there is a file with the affinities from IC contour.
%

imageInfo=xml_load(xmlFileName);
load(imageInfo.pb_affinities_name, 'A', 'row_num', 'col_num');


%
% Extract the affinities of the given points
% 

% convert the positions 'pos' into pixels coordinates. We assume that the
% coordinates are referred to the top left corner of the image. We also
% assume that the coordinates are spanning the same range of the image.

% the first coordinate is the x which correspond to the column of the
% image. The second coordinate is the y which correspond to the rows.
c_idx=round(pos(:, 1));
r_idx=round(pos(:, 2));

% we need to convert the indeces to the linear case
idx=sub2ind([row_num, col_num], r_idx, c_idx);

Ae=A(idx, idx);
Xe=[];


% AUTORIGHTS
% Copyright (C) 2008-2012 Marco Andreetto
%       
% This file is part of AB_SAMPLER.
% 
% AB_SAMPLER is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2, or (at your option)
% any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software Foundation,
% Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
