function [W, ix, iy]=xmlLoadAllPatchDesc(xmlFile, grid_step, visualWordInfo)

%
% Load all the different type of visual words for an input image describe
% in xmlFiles. The information about the dictionary are contained in 
%

% empty visual word.
W=[];

for h=1:length(visualWordInfo)
  
  % extract the information for computing 
  centers=visualWordInfo(h).centers;
  mu=visualWordInfo(h).mu;
  L=visualWordInfo(h).L;
  
  % compute the visual words depeding on the type of visual word
  
  switch (lower(visualWordInfo(h).type))
    
    case 'texture'
      [Wh, ix, iy]=xmlLoadPatchFilters(xmlFile, grid_step, centers, mu, L);
      
    case 'color'
      [Wh, ix, iy]=xmlLoadPatchColor(xmlFile, grid_step, centers);
      
    case 'sift'
      [Wh, ix, iy]=xmlLoadPatchSift(xmlFile, grid_step, centers);
      
    case 'hue'
      [Wh, ix, iy]=xmlLoadPatchHue(xmlFile, grid_step, centers);
      
    otherwise
      error('Unrecognized visual word type');
      
  end
  
  % add the visual words 
  W=cat(2, W, Wh);
  
end


% AUTORIGHTS
% Copyright (C) 2008-2012 Marco Andreetto
%       
% This file is part of AB_SAMPLER.
% 
% AB_SAMPLER is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2, or (at your option)
% any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software Foundation,
% Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
