function [W, ix, iy, R]=xmlLoadPatchColor(xmlFile, step, color_words)
%
% Load the color image and compute the quatized visual words for the specified 
% grid step.
%
% if recompute is set to true then the filter bank responce is recompute
%

% load the xmlFile
imageInfo=xml_load(xmlFile);

% generate the grid positions
[ix, iy, ix_rng, iy_rng]=getGridPositions(imageInfo.width, imageInfo.height, step);

% get the image (as double with 0-1 values)
I=im2double(imread(imageInfo.original_name));

% extract all the colors we need
R=reshape(I(iy_rng, ix_rng, :), [length(ix), 3]);

% compute the visual words labels
[~, W]=mindist(color_words', R');
W=W(:);

% AUTORIGHTS
% Copyright (C) 2008-2012 Marco Andreetto
%       
% This file is part of AB_SAMPLER.
% 
% AB_SAMPLER is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2, or (at your option)
% any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software Foundation,
% Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
