function [I, seg_size, seg, seg_list]=xmlShowProbTopic(k, h, xmlFilesInfo, ...
                                                       segFiles, fernFiles, ...
                                                       showFigure)

% by default we do not display the figure o
if nargin<5, showFigure=true; end

saveImages=true;

% load the image
I=im2double(imread(xmlFilesInfo{h}.original_name));

% load the segmentation and the assignment prob
load(segFiles{h}, 'segImageMAP', 'probImage');

[destDir, ~, ~]=fileparts(segFiles{h});

% % load the superpixel segmentation from ucm.
% load(xmlFilesInfo{h}.superpixels_name, 'sp');
% 
% % "smooth" the segmentation using the labels
% [segImageMAP, probImage]=compSPLabel(sp, segImageMAP, probImage); %#ok<NODEF>

% compute the size
seg_size=sum(sum(segImageMAP==k)); %#ok<*NODEF>

% blank color
blank_color=cat(3, 0.75, 0.75, 0.75); % this is white

% compute blended images
seg_list=blendSegment(I, probImage(:,:,k), blank_color);
seg=getSegment(I, segImageMAP==k, blank_color);

if (showFigure)
%   figure(111); clf
%   vl_tightsubplot(2,3,1); imshow(I);
%   vl_tightsubplot(2,3,2); imshow(probImage(:,:,k));
%   vl_tightsubplot(2,3,3); imshow(seg);
  
  % save also the images for future use
  if saveImages
    imwrite(seg, sprintf('%s/seg_topic_%03d_image_%04d.png', destDir, k, h));
    imwrite(probImage(:,:,k), ....
      sprintf('%s/prob_topic_%03d_image_%04d.png', destDir, k, h));
  end
  
  if nargin>=5
    load(fernFiles{h}, 'segImageMAP', 'probImage');
    % "smooth" the segmentation using the labels
    %[segImageMAP, probImage]=compSPLabel(sp, segImageMAP, probImage);

    fern_blend=blendSegment(I, probImage(:,:,k), blank_color);
    segFern=getSegment(I, segImageMAP==k, blank_color);
    
%     vl_tightsubplot(2,3,5); imshow(probImage(:,:,k));
%     vl_tightsubplot(2,3,6); imshow(segFern);

    % save also the images for future use
    if saveImages
      imwrite(segFern, sprintf('%s/seg_fern_%03d_image_%04d.png', destDir, k, h));
      imwrite(probImage(:,:,k), ....
        sprintf('%s/prob_fern_%03d_image_%04d.png', destDir, k, h));
    end
  end
end

  
function segment=blendSegment(I, P, blank_color)

segment=zeros(rows(I), cols(I), 3);

% background prob.
Q=1-P;

% just in case we are using gray scale pictures.
if size(I)==1, I=cat(3, I, I, I); end
  
for c=1:3
  plane=I(:,:,c).*P+ blank_color(1, 1, c)*Q;
  segment(:,:,c)=plane;
end


function segment=getSegment(I, idx, blank_color)

segment=zeros(rows(I), cols(I), 3);

% just in case we are using gray scale pictures.
if size(I)==1, I=cat(3, I, I, I); end
  
for c=1:3
  plane=I(:,:,c);
  plane(~idx)=blank_color(1, 1, c);
  segment(:,:,c)=plane;
end

% AUTORIGHTS
% Copyright (C) 2008-2012 Marco Andreetto
%       
% This file is part of AB_SAMPLER.
% 
% AB_SAMPLER is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2, or (at your option)
% any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software Foundation,
% Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
